<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <link rel="icon" href="https://i3lab.polimi.it/wp-content/uploads/2020/06/cropped-logo_single-32x32.png">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Vue</title>
    <script type="importmap">
        {
            "imports": {
            "vue": "https://unpkg.com/vue@3/dist/vue.esm-browser.js"
            }
        }
    </script>
</head>
  <body>
  <div id="app"></div>
  </body>
<script type="module">
    import { createApp, ref, defineProps, computed, watch } from 'vue'

    const app = createApp({
        setup() {
            const text = ref('')
            const h1 = computed(()=>'The value is '+text.value)
            watch(text,async (newVal,oldVal)=>{
                console.log(`Was ${oldVal}, is ${newVal}`)
            })
            const list = [1,2,3,4,5]
            function onClick(){
                text.value = 'blue'
            }
            return {text,h1,onClick,list}
        },
        template: `
            <h1>{{h1}}</h1>
            <input v-model="text">
            <button :style="{background: text}" @click="onClick">Click</button>
            <my-button @my-click="onClick">Component</my-button>
            <br>
            <ul>
              <li v-for="el of list">
                {{el}}
                <span v-if="el%2===0">even</span>
                <span v-else>odd</span>
              </li>
            </ul>
        `
    })

    app.component('my-button',{
        setup(){
        },

        template: `
            <button @click="$emit('my-click')">
              <slot></slot>
            </button>
        `
    })




    //Mount the app for it to be rendered
    app.mount('#app')
</script>
</html>